/*
Copyright (C) 2007 Kamal Singh.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

var channel = new Array();

channel[0] = {id:"OneXtra", title:"1Xtra", webLink:"http://www.bbc.co.uk/1xtra", link:"http://www.bbc.co.uk/1xtra/realmedia/1xtra.asx", image:"channels\\OneXtra.png", desc:"BBC 1Xtra - new urban and black music, plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[1] = {id:"BBCWrld", title:"BBC World Service", webLink:"http://www.bbc.co.uk/worldservice", link:"mms://wmevent3.broadcast.com/bcenc199178?StreamID=25962424&b=b9v7iakvt948i451b363d&CG_ID=57025", image:"channels\\BBCWrld.png", desc:"International news, analysis and information from the BBC World Service."};
channel[2] = {id:"BBCAsian", title:"BBC Asian Network", webLink:"http://www.bbc.co.uk/asiannetwork", link:"http://www.bbc.co.uk/asiannetwork/rams/asiannet_hi.asx", image:"channels\\BBCAsian.png", desc:"The BBC Asian Network is a BBC national radio station orientated towards British Asian life, culture and music in the UK and other topics from a British Asian perspective aimed at the under 35's from that community but aiming for a broader appeal among all interested in British Asian life whether Asian or not regardless of age."};
channel[3] = {id:"BBCRFiveX", title:"Five Live Sports Extra", webLink:"http://www.bbc.co.uk/fivelive/sportsextra", link:"http://www.bbc.co.uk/fivelive/live/live_sportsextra_int.asx", image:"channels\\BBCRFiveX.png", desc:"Sports Extra was set up by the team behind Five Live to bring you more sporting action. It's as simple as that. The station offers additional commentaries from the FA Barclays Premiership, Coca Cola League, Scottish Premier League and cup football - plus cricket, rugby, Formula One, tennis and golf."};
channel[4] = {id:"BBCROne", title:"BBC Radio 1", webLink:"http://www.bbc.co.uk/radio1", link:"http://www.bbc.co.uk/radio1/wm_asx/aod/radio1.asx", image:"channels\\BBCROne.png", desc:"BBC Radio 1 - youth oriented, mostly contemporary pop music (including Top 40 singles), plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[5] = {id:"BBCRTwo", title:"BBC Radio 2", webLink:"http://www.bbc.co.uk/radio2", link:"http://www.bbc.co.uk/radio2/wm_asx/aod/radio2.asx", image:"channels\\BBCRTwo.png", desc:"BBC Radio 2 - adult oriented entertainment, wide range of music - especially adult contemporary and middle of the road, also talk, comedy, plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[6] = {id:"BBCRThree", title:"BBC Radio 3", webLink:"http://www.bbc.co.uk/radio3", link:"http://www.bbc.co.uk/radio3/wm_asx/aod/radio3.asx", image:"channels\\BBCRThree.png", desc:"BBC Radio 3 - arts and high culture, special-interest music (classical, jazz, world music), plus news, original in-house live music sessions, original live music concerts & music documentaries."};
channel[7] = {id:"BBCRFour", title:"BBC Radio 4", webLink:"http://www.bbc.co.uk/radio4", link:"http://www.bbc.co.uk/radio4/wm_asx/aod/radio4.asx", image:"channels\\BBCRFour.png", desc:"BBC Radio 4 - news, current affairs, arts, original in-house drama, original in-house first-run comedy, science, books and religion."};
channel[8] = {id:"BBCRFiveL", title:"BBC Radio 5", webLink:"http://www.bbc.co.uk/fivelive", link:"http://www.bbc.co.uk/fivelive/live/live.asx", image:"channels\\BBCRFiveL.png", desc:"BBC Radio Five Live is the BBC's radio service providing live BBC News, phone-ins, and sports commentaries. It is the principal radio station covering sport in the United Kingdom, broadcasting virtually all major sports events staged in the UK or involving British competitors."};
channel[9] = {id:"BBCSeven", title:"BBC 7", webLink:"http://www.bbc.co.uk/bbc7", link:"http://www.bbc.co.uk/bbc7/realplayer/bbc7_hi.asx", image:"channels\\BBCSeven.png", desc:"BBC 7 - classic comedy, drama, books, science fiction, fantasy and children's programmes."};
channel[10] = {id:"BBCSixMU", title:"BBC 6 Music", webLink:"http://www.bbc.co.uk/6music", link:"http://www.bbc.co.uk/6music/ram/6music_hi.asx", image:"channels\\BBCSixMU.png", desc:"BBC 6 Music - rock, funk, punk and reggae, plus news, original in-house live music sessions, original live music concerts & music documentaries."};

wmp = WMPEmbed.object;
wmp.settings.volume = volume_control.value;

view.setInterval(updateCheck, 1000*60*5);

var channelNo = 0;
var animateCounter = 0;
view.setInterval(indicatorAnimation, 1000);

function onLoad() {
  getSchedule(channel[9].id);
  updateStaticInfo(9);
  wmp.controls.play();
  Start();
}

function updateCheck() {
  updateNowNext();
  updateStaticInfo(channelNo);
}

function buttonHandler() {
  wmp.controls.stop();
  Stop();
  if (channelNo == 10)
    channelNo = 0;
  else
    channelNo = channelNo + 1;
  updateNowNext(); 	// query the BBC Web API from shedule information for the current channel
  updateStaticInfo(channelNo);
  wmp.controls.play();
  Reset();
  Start();
}

function updateStaticInfo(channelNo) {
	var index = channel[channelNo];
	channelImage.src = index.image;
	channelLink.href = index.webLink;
	channelLink.tooltip = index.desc;
	wmp.URL = index.link;
}

function updateText() {
  nowTitle.innerText = results[0].title;
  nowTitle.tooltip = results[0].title;
  nowTime.innerText = results[0].start;
  nowTime.tooltip = results[0].start;
  nowSynopsis.innerText = results[0].synopsis;
  nowSynopsis.tooltip = results[0].synopsis;
}

function indicatorAnimation()	{
	if (animateCounter == 11)
		animateCounter = 0;
	else
		animateCounter = animateCounter + 1;

	indicator.src = "indicator\\indicator_large_" + animateCounter + ".png";
	displayStatus();
}

function onClickPlay() {
	wmp.controls.play();
	playButton.visible = false;
	stopButton.visible = true;
  Start();
}

function onClickStop() {
	wmp.controls.stop();
  playButton.visible = true;
	stopButton.visible = false;
  Stop();
}

// Timer related functions.
var timerID = 0;
var tStart  = null;

function UpdateTimer() {
  if(timerID) {
      clearTimeout(timerID);
      clockID = 0;
  }
  if(!tStart)
    tStart   = new Date();
  
  var tDate = new Date();
  var tDiff = tDate.getTime() - tStart.getTime();
  tDate.setTime(tDiff);
  duration.innerText = tDate.getMinutes() + ":" + tDate.getSeconds();   
  timerID = setTimeout("UpdateTimer()", 1000);
}

function Start() {
  tStart = new Date();
  duration.innerText = "00:00";
  timerID = setTimeout("UpdateTimer()", 1000);
}

function Stop() {
  if(timerID) {
    clearTimeout(timerID);
    timerID  = 0;
  }
  tStart = null;
}

function Reset() {
  tStart = null;
  duration.innerText = "00:00";
}

function volume_onchange() {
  if( wmp == null )
    return;
  wmp.settings.volume = volume_control.value;
}

function displayStatus() {
	if(wmp.playState == 0)
		status_message.innerText = "Undefined";
	else if(wmp.playState == 1)
		status_message.innerText = "Stopped";
	else if(wmp.playState == 2)
		status_message.innerText = "Paused";
	else if(wmp.playState == 3)
		status_message.innerText = "Playing";
	else if(wmp.playState == 4)
		status_message.innerText = "ScanForward";
	else if(wmp.playState == 5)
		status_message.innerText = "ScanReverse";
	else if(wmp.playState == 6)
		status_message.innerText = "Buffering";
	else if(wmp.playState == 7)
		status_message.innerText = "Waiting";
	else if(wmp.playState == 8)
		status_message.innerText = "MediaEnded";
	else if(wmp.playState == 9)
		status_message.innerText = "Transitioning";
	else if(wmp.playState == 10) {
		status_message.innerText = "Ready";
    wmp.controls.play();
  }
	else if(wmp.playState == 11)
		status_message.innerText = "Reconnecting";
}



//////////////
/////////////

var itemList;
var api_root = "http://www0.rdthdo.bbc.co.uk/cgi-perl/api/query.pl?";
var results;
var now = new Date();
var tzo = (now.getTimezoneOffset()/60)*-1

function updateNowNext() {
	// query the BBC Web API fro shedule information for the current channel
	getSchedule(channel[channelNo].id);
}

// Request the schedule for the current channel using the BBC Web API
function getSchedule(cURL) {
  var feedRequest = null;
  
  feedRequest = new XMLHttpRequest();
  try {
    var dDate = now.getDate();
    if(dDate < 10)
      dDate = "0" + dDate;
    var hHour = now.getHours();
    if(hHour < 10)
      hHour = "0" + hHour;
    var gmtTime = now.getFullYear() + "-0" + (now.getMonth()+1) + "-" + dDate + "T" + hHour + ":30" + ":00" + "Z"; 
    var url = api_root + "method=bbc.schedule.getProgrammes&channel_id=" + cURL + "&start=" + gmtTime + "&end=&limit=1&detail=schedule" + "&?sid=" + Math.random();
    debug.trace(url);
    feedRequest.open("GET", url, true);
  } 
  catch (e) {debug.trace(e);
    // Catch invalid URLs
    feedRequest = null;
    return;
  }
  
  // Set the callback for when the downloading is completed (or failed)
  feedRequest.onreadystatechange = onFeedLoad;
  
  // Start the download
  try {
    feedRequest.send();
  }
  catch (e) {
    // Catch errors sending the request
    feedRequest = null;
    return;
  }
  
  function onFeedLoad() {
    // Verify that the download completed
    if (feedRequest.readyState != 4)
      return;

    // Verify that the download was successful
    if (feedRequest.status != 200) {
      debug.trace("download failed");
      feedRequest = null;
      return;
    }

    var doc = new DOMDocument();
    doc.loadXML(feedRequest.responseText);
    var elem = doc.getElementsByTagName("programme");
    results = null;
    results = [];
    var title, synopsis, start;
    if (elem != null && elem.length > 0) {
      for (var z = 0; z < elem.length; z++) {        
        title = elem[z].getAttribute("title");
        debug.trace(title);
        for (var node = elem[z].firstChild; node != null; node = node.nextSibling) {
          if (node.nodeName == "synopsis") {
            try {
              synopsis = node.firstChild.nodeValue;debug.trace(synopsis);
            }            	
            catch (e) {
              synopsis = "error";
            }
          }
          if (node.nodeName == "start") {
            try {
              start = node.firstChild.nodeValue;
              start = convertDate(start);
            }            	
            catch (e) {
              start = "2007-07-10T23:00:00Z";
            }
          }
          results[z] = {synopsis:synopsis, title:title, start:start};
        }
      }
    }
    feedRequest = null;updateText();
  }
  
}

// Formats date standard string into human-readable form
// e.g. 2007-07-11T22:40:00Z
function convertDate(str) {
  var timeStr = "";
	var startPos = str.indexOf( "T", 0 );
	
	if ( tzo != 0 ) {
    var hourStr = str.substr( startPos + 1, 2 );
    var hour = stringToNumber( hourStr );
    timeStr = "" + hour + str.substr( startPos + 3, 8 );
  }
  else {
	  timeStr = str.substr( startPos + 1, 10 );
  }
	debug.trace(timeStr);
  var endPos = timeStr.indexOf( ":", 3 );
  timeStr = timeStr.substr( 0, endPos );		  

  return timeStr;
}

// translate a string to a number
function stringToNumber(str) {
  var num = 0;
	for (var i = 0; i<str.length; i++)
	  num += (str.charCodeAt(i) - 48) * Math.pow(10, (str.length - i - 1) );
  return num;
}		
